From b419eed03986068ded991d370b5859ce09198531 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 06 2020 01:32:58 +0000
Subject: [PATCH 1299/2232] Merge pull request #427 from dtolnay/unused


Validate that all exported_header_prefixes/_links are used
---

diff --git a/gen/build/src/error.rs b/gen/build/src/error.rs
index 5306564..e1cc345 100644
--- a/gen/build/src/error.rs
+++ b/gen/build/src/error.rs
@@ -16,6 +16,8 @@ pub(super) enum Error {
     ExportedDirsWithoutLinks,
     ExportedPrefixesWithoutLinks,
     ExportedLinksWithoutLinks,
+    UnusedExportedPrefix(&'static str),
+    UnusedExportedLinks(&'static str),
 }
 
 macro_rules! expr {
@@ -64,6 +66,18 @@ impl Display for Error {
                 expr!(CFG.exported_header_links),
                 LINKS_DOCUMENTATION,
             ),
+            Error::UnusedExportedPrefix(unused) => write!(
+                f,
+                "unused element in {}: {} does not match the include prefix of any direct dependency",
+                expr!(CFG.exported_header_prefixes),
+                unused,
+            ),
+            Error::UnusedExportedLinks(unused) => write!(
+                f,
+                "unused element in {}: {} does not match the `links` attribute any direct dependency",
+                expr!(CFG.exported_header_links),
+                unused,
+            ),
         }
     }
 }
diff --git a/gen/build/src/lib.rs b/gen/build/src/lib.rs
index b0df283..db15335 100644
--- a/gen/build/src/lib.rs
+++ b/gen/build/src/lib.rs
@@ -72,7 +72,8 @@ use crate::gen::Opt;
 use crate::paths::PathExt;
 use crate::target::TargetDir;
 use cc::Build;
-use std::collections::btree_map::{BTreeMap, Entry};
+use std::collections::btree_map::Entry;
+use std::collections::{BTreeMap, BTreeSet};
 use std::env;
 use std::ffi::{OsStr, OsString};
 use std::io::{self, Write};
@@ -270,21 +271,29 @@ fn make_this_crate(prj: &Project) -> Result<Crate> {
     }
 
     let mut header_dirs_index = BTreeMap::new();
+    let mut used_header_links = BTreeSet::new();
+    let mut used_header_prefixes = BTreeSet::new();
     for krate in deps::direct_dependencies() {
-        let is_link_exported = || match &krate.links {
+        let mut is_link_exported = || match &krate.links {
             None => false,
-            Some(links_attribute) => CFG
-                .exported_header_links
-                .iter()
-                .any(|exported| links_attribute == *exported),
+            Some(links_attribute) => CFG.exported_header_links.iter().any(|&exported| {
+                let matches = links_attribute == exported;
+                if matches {
+                    used_header_links.insert(exported);
+                }
+                matches
+            }),
         };
 
-        let is_prefix_exported = || match &krate.include_prefix {
+        let mut is_prefix_exported = || match &krate.include_prefix {
             None => false,
-            Some(include_prefix) => CFG
-                .exported_header_prefixes
-                .iter()
-                .any(|exported| include_prefix.starts_with(exported)),
+            Some(include_prefix) => CFG.exported_header_prefixes.iter().any(|&exported| {
+                let matches = include_prefix.starts_with(exported);
+                if matches {
+                    used_header_prefixes.insert(exported);
+                }
+                matches
+            }),
         };
 
         let exported = is_link_exported() || is_prefix_exported();
@@ -307,6 +316,22 @@ fn make_this_crate(prj: &Project) -> Result<Crate> {
         }
     }
 
+    if let Some(unused) = CFG
+        .exported_header_links
+        .iter()
+        .find(|&exported| !used_header_links.contains(exported))
+    {
+        return Err(Error::UnusedExportedLinks(unused));
+    }
+
+    if let Some(unused) = CFG
+        .exported_header_prefixes
+        .iter()
+        .find(|&exported| !used_header_prefixes.contains(exported))
+    {
+        return Err(Error::UnusedExportedPrefix(unused));
+    }
+
     Ok(this_crate)
 }
 

